/*  
XML Import Skript 
Version:     	1.0
License:	CC 
Last-Change:	9. November 2009

Autor + Copyright: Gregor Fellenz
http://www.indesignblog.com/
*/

#target InDesign 

xmlImport () ;

// Main function for export 
function xmlImport () {	
	
	// Check if any Document is open
	if (app.documents.length == 0 ) {
			alert ("No open Document!", "Error")
			app.scriptPreferences.userInteractionLevel = myOldInteraction;
			exit(0);
	}

	// Load XML File 
	var _xmlFile = File.openDialog ("Bitte wählen Sie die zu verarbeitende XML Datei aus", "XML Dateien:*.xml" , false);
		if (_xmlFile == null) {
			alert ("Fehler bei Dateiauswahl!")
			exit(0);
		}
	_dokument = app.activeDocument;
	_dokument = app.activeDocument;
	
	var myXMLImportPreferences = _dokument.xmlImportPreferences;
	myXMLImportPreferences.allowTransform = false;
	myXMLImportPreferences.createLinkToXML = false;
	myXMLImportPreferences.ignoreUnmatchedIncoming = false;
	myXMLImportPreferences.ignoreWhitespace = true; 
	myXMLImportPreferences.importCALSTables = true;
	myXMLImportPreferences.importStyle = XMLImportStyles.mergeImport;
	myXMLImportPreferences.importTextIntoTables = false;
	myXMLImportPreferences.importToSelected = false;
	myXMLImportPreferences.removeUnmatchedExisting = false;
	myXMLImportPreferences.repeatTextElements = true;
	//AllowTransform property must set to True.
	//myXMLImportPreferences.transformFilename = File( _path +  "/scripts/xml2indesign.xslt");
	//If you have defined parameters in your XSL file, then you can pass
	//parameters to the file during the XML import process. For each parameter,
	//enter an array containing two strings. The first string is the name of the
	//parameter, the second is the value of the parameter.
	//myXMLImportPreferences.transformParameters = [["format", "1"]];
		
	_dokument.importXML(_xmlFile);	
	
	// Get List of Block Level Elements from XML Tag Mapping an Process!!
	for (i = 0; i < _dokument.xmlImportMaps.length; i++) {
		if (_dokument.xmlImportMaps[i].mappedStyle.constructor.name == "ParagraphStyle" ) {					
			var _xpath = "//" + _dokument.xmlImportMaps[i].markupTag.name;
			var node  = null; 
			try { 
				var _proc  = app.xmlRuleProcessors.add([_xpath]); 
				var _match = _proc.startProcessingRuleSet(_dokument.xmlElements[0]); 
				while( _match!=undefined ) { 
					_node = _match.element; 
					_node.insertTextAsContent ("\r", XMLElementPosition.afterElement)
					_match = _proc.findNextMatch(); 
				}     
			}			
			catch( ex ) { 
				throw (ex); 
			} finally { 
				_proc.endProcessingRuleSet(); 
				_proc.remove(); 
			} 
		} //end if
	} // end for 	
}